<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Declinaison.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Declinaisondesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Venteprod.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produit.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Ventedeclibre.class.php");

	class Declibre extends PluginsClassiques{
       
		var $id;
		var $ref;
		var $declinaison;
		var $stock;
		var $prix;
		var $prix2;

		var $table = "declibre";

		var $bddvars=array("id", "ref", "declinaison", "stock", "prix", "prix2");

		
		function Declibre(){
			$this->PluginsClassiques("declibre");
		}

		function init(){
			$query_declibre = "CREATE TABLE `declibre` (
								`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
								`ref` TEXT NOT NULL ,
								`declinaison` TEXT NOT NULL ,
								`stock` FLOAT NOT NULL ,
								`prix` FLOAT NOT NULL ,
								`prix2` FLOAT NOT NULL
							);";
			$resul_declibre = mysql_query($query_declibre, $this->link);
						
			$ventedeclilibre = new Ventedeclibre();
			$ventedeclilibre->init();
		}		

        function charger($ref){
                return $this->getVars("select * from $this->table where ref=\"$ref\"");
        }

        function charger_id($id){
                return $this->getVars("select * from $this->table where id=\"$id\"");
        }
        
        
        function demarrage(){
			global $action, $nouveau;
			$trouve = 1;
          if($_REQUEST['action'] == "ajouter" && $_REQUEST['id_declibre'] != ""){
        	$declibre = new Declibre();
        	$declibre->charger_id($_REQUEST['id_declibre']);
        	if($declibre->ref != $_REQUEST['ref']){
        		$action = "";
        		$trouve=0;
        	}
        		
        	
        	
        	for($i = 0; $i<$_SESSION['navig']->panier->nbart; $i++){
        		if($_REQUEST['ref'] == $_SESSION['navig']->panier->tabarticle[$i]->produit->ref && $_SESSION['navig']->declibre[$i] == $_REQUEST['id_declibre']){
					$trouve = 0;
				}
             }	
        	        	
        	if($trouve == 1){
        		$_REQUEST['nouveau'] = 1;
        		$GLOBALS['declibre_traite'] = 1;
        		$nouveau=1;
        	}
          }
    	  
        }

	
		function boucle($texte, $args){
			
			$boucle = lireTag($args, "boucle");

			if($boucle == "declinaison")
				return $this->boucle_declinaison($texte, $args);
			else 			
				if($boucle == "panier")
					return $this->boucle_panier($texte, $args);

		}


		function boucle_declinaison($texte, $args){
			$id = lireTag($args, "id");
			$ref = lireTag($args, "ref");
			$declinaison = lireTag($args, "declinaison");
			$stockmini = lireTag($args, "stockmini");
			$num = lireTag($args, "num");
			$article =  lireTag($args, "article");

            $search ="";
            $res="";
			$order = "order by declinaison";
            $limit="";

            if($num != "")
                    $limit = "limit 0,$num";

		    if($id != "") $search .= " and id=\"$id\"";
            if($ref != "") $search .= " and ref=\"$ref\"";
            if($declinaison != "") $search .= " and declinaison=\"$declinaison\"";
            if($stockmini != "") $search .= " and stock>=\"$stockmini\"";

            $query_declibre = "select * from $this->table where 1 $search $order $limit";
            $resul_declibre = mysql_query($query_declibre, $this->link);

            $nbres = mysql_numrows($resul_declibre);
            if(!$nbres) return "";

            while( $row = mysql_fetch_object($resul_declibre)){
	              $prix = number_format($row->prix, 2, ".", "");
    	       	  $prix2 = number_format($row->prix2, 2, ".", "");

				  $prod = new Produit();
				  $prod->charger($row->ref);
				  
                  $temp = str_replace("#ID", $row->id, $texte);
                  $temp = str_replace("#REF", $row->ref, $temp);
                  $temp = str_replace("#DECLINAISON", $row->declinaison, $temp);
                  $temp = str_replace("#STOCK", $row->stock, $temp);
                  $temp = str_replace("#PRIX2", $prix2, $temp);
                  $temp = str_replace("#PRIX", $prix, $temp);
                  $temp = str_replace("#PROMO", $prod->promo, $temp);
                  $temp = str_replace("#ARTICLE", $row->article, $temp);
		          $res .= $temp;

		    }

		    return $res;			
		}
		
		
		function boucle_panier($texte, $args){
			$article =  lireTag($args, "article");

			if($article == "" || $_SESSION['navig']->declibre[$article] == "")
				return "";
				
			$this->charger_id($_SESSION['navig']->declibre[$article]);
					
			$texte = str_replace("#DECLIBRE", $_SESSION['navig']->declibre[$article], $texte);
			$texte = str_replace("#STOCK", $this->stock, $texte);
			$texte = str_replace("#ARTICLE", $article, $texte);
			
			return $texte;
							
		}
		
		
		function action(){

			global $res;			
	
			$res = str_replace("#DECLIBRE_ID", $_REQUEST['id_declibre'], $res);

			if($_REQUEST['action'] == "ajouter" && $GLOBALS['declibre_traite']){

				$nb = $_SESSION['navig']->panier->nbart;
	
				if($_REQUEST['id_declibre'] != ""){
							
						$nb = $_SESSION['navig']->panier->nbart;

						if($_REQUEST['id_declibre'] != ""){
							$this->charger_id($_REQUEST['id_declibre']);
							$_SESSION['navig']->declibre[$nb-1] = $_REQUEST['id_declibre'];
							$_SESSION['navig']->panier->tabarticle[$nb-1]->produit->prix = $this->prix;
							$_SESSION['navig']->panier->tabarticle[$nb-1]->produit->prix2 = $this->prix2;
							
						}	
				
				}	
		
			} else if($_REQUEST['action'] == "supprimer" && $_REQUEST['article'] != ""){
			
				for($i=$_REQUEST['article']; $i < $_SESSION['navig']->panier->nbart; $i++){
					if(isset($_SESSION['navig']->declibre[$i+1]))
						$_SESSION['navig']->declibre[$i] = $_SESSION['navig']->declibre[$i+1];
					
				}
			
			}


		}
	
		
		function aprescommande($commande){
	
			for($i=0; $i< $_SESSION['navig']->panier->nbart; $i++)
				if($_SESSION['navig']->declibre[$i]){

					$this->charger_id($_SESSION['navig']->declibre[$i]);
					$this->stock -= $_SESSION['navig']->panier->tabarticle[$i]->quantite;
					$this->maj();
											
					$venteprod = new Venteprod();
					$query = "select * from $venteprod->table where commande=\"" .$commande->id . "\" order by id limit $i,1";
					$resul = mysql_query($query, $venteprod->link);		
					$row = mysql_fetch_object($resul);
					
					$tmp = new Venteprod();
					$tmp->charger($row->id);
					$tmp->titre .= " " . $this->declinaison;
					$tmp->maj();
								
					$ventedeclibre = new Ventedeclibre();
					$ventedeclibre->venteprod = $row->id;
					$ventedeclibre->declibre = 	$_SESSION['navig']->declibre[$i];
					$ventedeclibre->add();	
				}				
		
		}
		
		function statut($commande){
			if($commande->statut == "5"){
		 		$venteprod = new Venteprod();
		   		$query = "select * from $venteprod->table where commande='" . $commande->id . "'";
		   		$resul = mysql_query($query, $venteprod->link);

				while($row = mysql_fetch_object($resul)){
				
					$vdec = new Ventedeclibre();

					$query2 = "select * from $vdec->table where venteprod='" . $row->id . "'";
					$resul2 = mysql_query($query2, $vdec->link);


					while($row2 = mysql_fetch_object($resul2)){
						$declibre = new Declibre();
						$declibre->charger_id($row2->declibre);
						$declibre->stock = $declibre->stock + $row->quantite;
						$declibre->maj();				
					}
				
		 	   }
		     }
	   }
	}

?>
